<?php

declare(strict_types=1);

namespace App\Policies;

use App\Models\SubLocation;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class SubLocationPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:SubLocation');
    }

    public function view(AuthUser $authUser, SubLocation $subLocation): bool
    {
        return $authUser->can('View:SubLocation');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:SubLocation');
    }

    public function update(AuthUser $authUser, SubLocation $subLocation): bool
    {
        return $authUser->can('Update:SubLocation');
    }

    public function delete(AuthUser $authUser, SubLocation $subLocation): bool
    {
        return $authUser->can('Delete:SubLocation');
    }

    public function restore(AuthUser $authUser, SubLocation $subLocation): bool
    {
        return $authUser->can('Restore:SubLocation');
    }

    public function forceDelete(AuthUser $authUser, SubLocation $subLocation): bool
    {
        return $authUser->can('ForceDelete:SubLocation');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:SubLocation');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:SubLocation');
    }

    public function replicate(AuthUser $authUser, SubLocation $subLocation): bool
    {
        return $authUser->can('Replicate:SubLocation');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:SubLocation');
    }
}
